﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Linq;
    using Eco.Core.Items;
    using Eco.Core.Utils;
    using Eco.Core.Utils.AtomicAction;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Services;
    using Eco.Shared.Utils;
    using Gameplay.Systems.Tooltip;

    /// <summary>Auto-generated class. Don't modify it! All your changes will be wiped with next update! Use Mods* partial methods instead for customization.</summary>
    [Serialized]
    [LocDisplayName("Milling")]
    [Ecopedia("Professions", "Farmer", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    [RequiresSkill(typeof(FarmerSkill), 0), Tag("Farmer Specialty"), Tier(3)]
    [Tag("Specialty")]
    [Tag("Teachable")]
    public partial class MillingSkill : Skill
    {
        public override LocString DisplayDescription { get { return Localizer.DoStr("Milling various products can create important materials for baking and other uses. Levels up by crafting related recipes."); } }

        public override void OnLevelUp(User user)
        {
            user.Skillset.AddExperience(typeof(SelfImprovementSkill), 20, Localizer.DoStr("for leveling up another specialization."));
        }


        public static MultiplicativeStrategy MultiplicativeStrategy =
            new MultiplicativeStrategy(new float[] { 
                1,
                1 - 0.2f,
                1 - 0.25f,
                1 - 0.3f,
                1 - 0.35f,
                1 - 0.4f,
                1 - 0.45f,
                1 - 0.5f,
            });
        public override MultiplicativeStrategy MultiStrategy => MultiplicativeStrategy;

        public static AdditiveStrategy AdditiveStrategy =
            new AdditiveStrategy(new float[] { 
                0,
                0.5f,
                0.55f,
                0.6f,
                0.65f,
                0.7f,
                0.75f,
                0.8f,
            });
        public override AdditiveStrategy AddStrategy => AdditiveStrategy;
        public override int MaxLevel { get { return 7; } }
        public override int Tier { get { return 3; } }
    }

    [Serialized]
    [LocDisplayName("Milling Skill Book")]
    [Ecopedia("Items", "Skill Books", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    public partial class MillingSkillBook : SkillBook<MillingSkill, MillingSkillScroll> {}

    [Serialized]
    [LocDisplayName("Milling Skill Scroll")]
    public partial class MillingSkillScroll : SkillScroll<MillingSkill, MillingSkillBook> {}


    [RequiresSkill(typeof(FarmingSkill), 1)]
    public partial class MillingSkillBookRecipe : RecipeFamily
    {
        public MillingSkillBookRecipe()
        {
            var recipe = new Recipe();
            recipe.Init(
                "Milling",  //noloc
                Localizer.DoStr("Milling Skill Book"),
                new List<IngredientElement>
                {
                    new IngredientElement(typeof(DendrologyResearchPaperBasicItem), 5, typeof(FarmingSkill)),
                    new IngredientElement(typeof(GeologyResearchPaperBasicItem), 5, typeof(FarmingSkill)),
                    new IngredientElement(typeof(CulinaryResearchPaperBasicItem), 5, typeof(FarmingSkill)),
                    new IngredientElement(typeof(EngineeringResearchPaperAdvancedItem), 5, typeof(FarmingSkill)),
                    new IngredientElement("Basic Research", 15, typeof(FarmingSkill)), //noloc
                    new IngredientElement(typeof(PaperItem), 3, typeof(GatheringSkill)), //noloc
                },
                new List<CraftingElement>
                {
                    new CraftingElement<MillingSkillBook>()
                });
            this.Recipes = new List<Recipe> { recipe };
            this.LaborInCalories = CreateLaborInCaloriesValue(3000, typeof(FarmingSkill));
            this.CraftMinutes = CreateCraftTimeValue(typeof(MillingSkillBookRecipe), 15, typeof(FarmingSkill));
            this.ModsPreInitialize();
            this.Initialize(Localizer.DoStr("Milling Skill Book"), typeof(MillingSkillBookRecipe));
            this.ModsPostInitialize();
            CraftingComponent.AddRecipe(typeof(ResearchTableObject), this);
        }

        /// <summary>Hook for mods to customize RecipeFamily before initialization. You can change recipes, xp, labor, time here.</summary>
        partial void ModsPreInitialize();
        /// <summary>Hook for mods to customize RecipeFamily after initialization, but before registration. You can change skill requirements here.</summary>
        partial void ModsPostInitialize();
    }
}
