﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Core.Items;
    using Eco.World;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;

    public partial class SealOfApprovalRecipe : RecipeFamily
    {
        public SealOfApprovalRecipe()
        {
            var recipe = new Recipe();
            recipe.Init(
                "Seal Of Approval",  //noloc
                Localizer.DoStr("Seal Of Approval"),
                new List<IngredientElement>
                {
                    new IngredientElement(typeof(GoldSealItem), 1, typeof(SmeltingSkill)),
                },
                new List<CraftingElement>
                {
                    new CraftingElement<SealOfApprovalItem>()
                });
            this.Recipes = new List<Recipe> { recipe };
            this.ExperienceOnCraft = 1;
            this.LaborInCalories = CreateLaborInCaloriesValue(50, typeof(SmeltingSkill));
            this.CraftMinutes = CreateCraftTimeValue(typeof(SealOfApprovalRecipe), .5f, typeof(SmeltingSkill), typeof(SmeltingFocusedSpeedTalent), typeof(SmeltingParallelSpeedTalent));
            this.ModsPreInitialize();
            this.Initialize(Localizer.DoStr("Seal Of Approval"), typeof(SealOfApprovalRecipe));
            this.ModsPostInitialize();
            CraftingComponent.AddRecipe(typeof(CapitolObject), this);
        }

        /// <summary>Hook for mods to customize RecipeFamily before initialization. You can change recipes, xp, labor, time here.</summary>
        partial void ModsPreInitialize();
        /// <summary>Hook for mods to customize RecipeFamily after initialization, but before registration. You can change skill requirements here.</summary>
        partial void ModsPostInitialize();
    }


    /// <summary>Auto-generated class. Don't modify it! All your changes will be wiped with next update! Use Mods* partial methods instead for customization.</summary>
    [Serialized]
    [LocDisplayName("Seal of Approval")]
    [Weight(100)]
    [Ecopedia("Items", "Products", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    public partial class SealOfApprovalItem : Item
    {
        public override LocString DisplayDescription { get { return Localizer.DoStr("A Seal of Approval given by the Government, authorizing the creation of Land Claim Papers"); } }
    }
}