﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Core.Items;
    using Eco.World;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;


    [RequiresSkill(typeof(PaperMillingSkill), 3)]
    public partial class SecurityPaperRecipe : RecipeFamily
    {
        public SecurityPaperRecipe()
        {
            var recipe = new Recipe();
            recipe.Init(
                "Security Paper",  //noloc
                Localizer.DoStr("Security Paper"),
                new List<IngredientElement>
                {
                    new IngredientElement(typeof(PaperItem), 5, typeof(PaperMillingSkill), typeof(PaperMillingLavishResourcesTalent)),
                    new IngredientElement(typeof(IronBarItem), 1, typeof(PaperMillingSkill), typeof(PaperMillingLavishResourcesTalent)),
                },
                new List<CraftingElement>
                {
                    new CraftingElement<SecurityPaperItem>()
                });
            this.Recipes = new List<Recipe> { recipe };
            this.ExperienceOnCraft = 5;
            this.LaborInCalories = CreateLaborInCaloriesValue(60, typeof(PaperMillingSkill));
            this.CraftMinutes = CreateCraftTimeValue(typeof(SecurityPaperRecipe), 0.75f, typeof(PaperMillingSkill), typeof(PaperMillingFocusedSpeedTalent), typeof(PaperMillingParallelSpeedTalent));
            this.ModsPreInitialize();
            this.Initialize(Localizer.DoStr("Security Paper"), typeof(SecurityPaperRecipe));
            this.ModsPostInitialize();
            CraftingComponent.AddRecipe(typeof(OldPrintingPressObject), this);
        }

        /// <summary>Hook for mods to customize RecipeFamily before initialization. You can change recipes, xp, labor, time here.</summary>
        partial void ModsPreInitialize();
        /// <summary>Hook for mods to customize RecipeFamily after initialization, but before registration. You can change skill requirements here.</summary>
        partial void ModsPostInitialize();
    }

    [Serialized]
    [LocDisplayName("Security Paper")]
    [Weight(100)]
    [Fuel(100)]
    [Tag("Fuel")]
    [Tag("Currency")]
    [Currency]
    [Ecopedia("Items", "Products", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    [Tag("Burnable Fuel", 1)]
    public partial class SecurityPaperItem : Item
    {
        public override LocString DisplayDescription { get { return Localizer.DoStr("It's a Security Paper, used for official documents. Totally not copyable."); } }
    }
}